> For the complete documentation index, see [llms.txt](https://docs.stacks.co/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.stacks.co/reference/stacks.js/stacks-transactions/utilities/cvtovalue.md).

# cvToValue

Extracts the JavaScript value from a Clarity value object.

***

### Usage

```ts
import { cvToValue, Cl } from '@stacks/transactions';

cvToValue(Cl.uint(100));
// 100n (bigint)

cvToValue(Cl.bool(true));
// true

cvToValue(Cl.stringAscii('hello'));
// 'hello'

cvToValue(Cl.none());
// null

// With strict JSON compatibility (integers as strings)
cvToValue(Cl.uint(100), true);
// '100' (string)
```

[**Reference Link**](https://github.com/stx-labs/stacks.js/tree/main/packages/transactions/src/clarity/clarityValue.ts#L86)

***

### Signature

```ts
function cvToValue(val: ClarityValue, strictJsonCompat?: boolean): any;
```

***

### Returns

`any`

The JavaScript representation of the Clarity value. Types map as follows:

| Clarity Type                  | JS Type                                                |
| ----------------------------- | ------------------------------------------------------ |
| `bool`                        | `boolean`                                              |
| `int`, `uint`                 | `bigint` (or `string` if `strictJsonCompat` is `true`) |
| `buffer`                      | `string` (hex with `0x` prefix)                        |
| `none`                        | `null`                                                 |
| `some`                        | Wrapped value via `cvToJSON`                           |
| `ok`, `err`                   | Wrapped value via `cvToJSON`                           |
| `principal`                   | `string`                                               |
| `string-ascii`, `string-utf8` | `string`                                               |
| `list`                        | `any[]`                                                |
| `tuple`                       | `Record<string, any>`                                  |

***

### Parameters

#### val (required)

* **Type**: `ClarityValue`

The Clarity value to extract the JS value from.

#### strictJsonCompat (optional)

* **Type**: `boolean`

If `true`, integers are returned as strings instead of `bigint` for JSON serialization. Defaults to `false`.


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter, and the optional `goal` query parameter:

```
GET https://docs.stacks.co/reference/stacks.js/stacks-transactions/utilities/cvtovalue.md?ask=<question>&goal=<endgoal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is optional and describes the broader end goal you are ultimately trying to accomplish on behalf of the user. GitBook uses it to tailor the answer towards what is most useful for that goal.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
